diff -u cvs/hq/wine/Make.rules.in wine/Make.rules.in
--- cvs/hq/wine/Make.rules.in	Tue Apr 17 10:44:28 2001
+++ wine/Make.rules.in	Tue May  1 16:03:07 2001
@@ -157,7 +157,7 @@
 	w32skrnl \
 	winedos \
 	wineoss.drv \
-	wineps \
+	wineps.drv \
 	wininet \
 	winmm \
 	winnls32 \
diff -u cvs/hq/wine/dlls/Makefile.in wine/dlls/Makefile.in
--- cvs/hq/wine/dlls/Makefile.in	Thu Apr 19 21:19:24 2001
+++ wine/dlls/Makefile.in	Tue May  1 16:04:50 2001
@@ -60,7 +60,7 @@
 	win32s/libw32skrnl.@LIBEXT@ \
 	winaspi/libwnaspi32.@LIBEXT@ \
 	winedos/libwinedos.@LIBEXT@ \
-	wineps/libwineps.@LIBEXT@ \
+	wineps/libwineps.drv.@LIBEXT@ \
 	wininet/libwininet.@LIBEXT@ \
 	winmm/joystick/libjoystick.drv.@LIBEXT@ \
 	winmm/libwinmm.@LIBEXT@ \
@@ -121,7 +121,7 @@
 	win87em \
 	winaspi \
 	windebug \
-	wineps16 \
+	wineps16.drv \
 	wing \
 	winnls \
 	winsock \
@@ -378,8 +378,8 @@
 libwineoss.drv.@LIBEXT@: winmm/wineoss/libwineoss.drv.@LIBEXT@
 	$(RM) $@ && $(LN_S) winmm/wineoss/libwineoss.drv.@LIBEXT@ $@
 
-libwineps.@LIBEXT@ libwineps16.@LIBEXT@: wineps/libwineps.@LIBEXT@
-	$(RM) $@ && $(LN_S) wineps/libwineps.@LIBEXT@ $@
+libwineps.drv.@LIBEXT@ libwineps16.drv.@LIBEXT@: wineps/libwineps.drv.@LIBEXT@
+	$(RM) $@ && $(LN_S) wineps/libwineps.drv.@LIBEXT@ $@
 
 libwininet.@LIBEXT@: wininet/libwininet.@LIBEXT@
 	$(RM) $@ && $(LN_S) wininet/libwininet.@LIBEXT@ $@
@@ -461,7 +461,7 @@
 win32s/libw32skrnl.@LIBEXT@: libkernel32.@LIBEXT@ libntdll.@LIBEXT@
 winaspi/libwnaspi32.@LIBEXT@: libadvapi32.@LIBEXT@ libkernel32.@LIBEXT@ libntdll.@LIBEXT@
 winedos/libwinedos.@LIBEXT@: libuser32.@LIBEXT@ libkernel32.@LIBEXT@ libntdll.@LIBEXT@
-wineps/libwineps.@LIBEXT@: libuser32.@LIBEXT@ libgdi32.@LIBEXT@ libwinspool.drv.@LIBEXT@ libkernel32.@LIBEXT@ libntdll.@LIBEXT@
+wineps/libwineps.drv.@LIBEXT@: libuser32.@LIBEXT@ libgdi32.@LIBEXT@ libwinspool.drv.@LIBEXT@ libkernel32.@LIBEXT@ libntdll.@LIBEXT@
 wininet/libwininet.@LIBEXT@: libshlwapi.@LIBEXT@ libuser32.@LIBEXT@ libkernel32.@LIBEXT@ libntdll.@LIBEXT@
 winmm/joystick/libjoystick.drv.@LIBEXT@: libwinmm.@LIBEXT@ libuser32.@LIBEXT@ libntdll.@LIBEXT@
 winmm/libwinmm.@LIBEXT@: libuser32.@LIBEXT@ libadvapi32.@LIBEXT@ libkernel32.@LIBEXT@ libntdll.@LIBEXT@
diff -u cvs/hq/wine/dlls/wineps/.cvsignore wine/dlls/wineps/.cvsignore
--- cvs/hq/wine/dlls/wineps/.cvsignore	Fri Dec  1 03:57:38 2000
+++ wine/dlls/wineps/.cvsignore	Tue May  1 16:12:03 2001
@@ -1,4 +1,4 @@
 Makefile
 rsrc.res
-wineps.spec.c
-wineps16.spec.c
+wineps.drv.spec.c
+wineps16.drv.spec.c
diff -u cvs/hq/wine/dlls/wineps/Makefile.in wine/dlls/wineps/Makefile.in
--- cvs/hq/wine/dlls/wineps/Makefile.in	Mon Apr 30 20:20:35 2001
+++ wine/dlls/wineps/Makefile.in	Tue May  1 15:36:55 2001
@@ -2,9 +2,9 @@
 TOPOBJDIR = ../..
 SRCDIR    = @srcdir@
 VPATH     = @srcdir@
-MODULE    = wineps
+MODULE    = wineps.drv
 SOVERSION = 1.0
-ALTNAMES  = wineps16
+ALTNAMES  = wineps16.drv
 IMPORTS   = user32 gdi32 winspool.drv kernel32 ntdll
 EXTRALIBS = @CUPSLIBS@
 
diff -u cvs/hq/wine/dlls/wineps/wineps.drv.spec wine/dlls/wineps/wineps.drv.spec
--- /dev/null	Wed May  6 05:32:27 1998
+++ wine/dlls/wineps/wineps.drv.spec	Tue May  1 15:36:00 2001
@@ -0,0 +1,13 @@
+name	wineps
+file    wineps.drv
+type	win32
+init	PSDRV_Init
+rsrc	rsrc.res
+
+import	user32.dll
+import	gdi32.dll
+import	winspool.drv
+import	kernel32.dll
+import	ntdll.dll
+
+debug_channels (psdrv)
diff -u cvs/hq/wine/dlls/wineps/wineps.spec wine/dlls/wineps/wineps.spec
--- cvs/hq/wine/dlls/wineps/wineps.spec	Fri Apr  6 20:07:08 2001
+++ /dev/null	Wed May  6 05:32:27 1998
@@ -1,12 +0,0 @@
-name	wineps
-type	win32
-init	PSDRV_Init
-rsrc	rsrc.res
-
-import	user32.dll
-import	gdi32.dll
-import	winspool.drv
-import	kernel32.dll
-import	ntdll.dll
-
-debug_channels (psdrv)
diff -u cvs/hq/wine/dlls/wineps/wineps16.drv.spec wine/dlls/wineps/wineps16.drv.spec
--- /dev/null	Wed May  6 05:32:27 1998
+++ wine/dlls/wineps/wineps16.drv.spec	Tue May  1 15:34:57 2001
@@ -0,0 +1,9 @@
+name    wineps16
+file    wineps16.drv
+type    win16
+owner	wineps
+
+13 pascal16 DeviceMode(word word str str) PSDRV_DeviceMode16
+90 pascal16 ExtDeviceMode(word word ptr str str ptr str word) PSDRV_ExtDeviceMode16
+91 pascal DeviceCapabilities(str str word ptr ptr) PSDRV_DeviceCapabilities16
+93 pascal16 AdvancedSetupDialog(word word ptr ptr) PSDRV_AdvancedSetupDialog16
diff -u cvs/hq/wine/dlls/wineps/wineps16.spec wine/dlls/wineps/wineps16.spec
--- cvs/hq/wine/dlls/wineps/wineps16.spec	Fri Jul 28 09:07:20 2000
+++ /dev/null	Wed May  6 05:32:27 1998
@@ -1,8 +0,0 @@
-name    wineps16
-type    win16
-owner	wineps
-
-13 pascal16 DeviceMode(word word str str) PSDRV_DeviceMode16
-90 pascal16 ExtDeviceMode(word word ptr str str ptr str word) PSDRV_ExtDeviceMode16
-91 pascal DeviceCapabilities(str str word ptr ptr) PSDRV_DeviceCapabilities16
-93 pascal16 AdvancedSetupDialog(word word ptr ptr) PSDRV_AdvancedSetupDialog16
diff -u cvs/hq/wine/dlls/winspool/info.c wine/dlls/winspool/info.c
--- cvs/hq/wine/dlls/winspool/info.c	Mon Apr 30 20:20:49 2001
+++ wine/dlls/winspool/info.c	Tue May  1 16:21:19 2001
@@ -113,9 +113,9 @@
 	unlink(ppd);
 
 	if (!strcmp(def,dests[i].name)) {
-		char	*buf = HeapAlloc(GetProcessHeap(),0,2*strlen(dests[i].name)+strlen(",WINEPS,CUPS:")+1);
+		char	*buf = HeapAlloc(GetProcessHeap(),0,2*strlen(dests[i].name)+strlen(",WINEPS.DRV,CUPS:")+1);
 
-		sprintf(buf,"%s,WINEPS,CUPS:%s",dests[i].name,dests[i].name);
+		sprintf(buf,"%s,WINEPS.DRV,CUPS:%s",dests[i].name,dests[i].name);
 		WriteProfileStringA("windows","device",buf);
 		HeapFree(GetProcessHeap(),0,buf);
 	}
@@ -133,8 +133,8 @@
 	pinfo2a.pShareName	= "<share name?>";
 	pinfo2a.pSepFile	= "<sep file?>";
 
-	devline=HeapAlloc(GetProcessHeap(),0,strlen("WINEPS,")+strlen(port)+1);
-	sprintf(devline,"WINEPS,%s",port);
+	devline=HeapAlloc(GetProcessHeap(),0,strlen("WINEPS.DRV,")+strlen(port)+1);
+	sprintf(devline,"WINEPS.DRV,%s",port);
 	WriteProfileStringA("devices",dests[i].name,devline);
 	HeapFree(GetProcessHeap(),0,devline);
 
diff -u cvs/hq/wine/documentation/installation-und-konfiguration.german wine/documentation/installation-und-konfiguration.german
--- cvs/hq/wine/documentation/installation-und-konfiguration.german	Fri Jan 19 07:03:47 2001
+++ wine/documentation/installation-und-konfiguration.german	Tue May  1 16:08:01 2001
@@ -1616,10 +1616,10 @@
    Änderungen vorzunehmen:
 
    [windows]
-   device=WINE PostScript Driver,WINEPS,LPT1:
+   device=WINE PostScript Driver,WINEPS.DRV,LPT1:
 
    [devices]
-   WINE PostScript Driver=WINEPS,LPT1:
+   WINE PostScript Driver=WINEPS.DRV,LPT1:
 
    Falls Sie WINE ohne eine bestehende Windows-Installation verwenden,
    kann es sein, dass die Datei win.ini noch nicht existiert. In
diff -u cvs/hq/wine/documentation/packaging.sgml wine/documentation/packaging.sgml
--- cvs/hq/wine/documentation/packaging.sgml	Sat Jan 20 04:50:50 2001
+++ wine/documentation/packaging.sgml	Tue May  1 16:08:43 2001
@@ -454,7 +454,7 @@
 <member>libversion.so.1.0</>
 <member>libw32skrnl.so.1.0</>
 <member>libwnaspi32.so.1.0</>
-<member>libwineps.so.1.0</>
+<member>libwineps.drv.so.1.0</>
 <member>libwininet.so.1.0</>
 <member>libjoystick.drv.so.1.0</>
 <member>libwinmm.so.1.0</>
@@ -1654,7 +1654,7 @@
 w32skrnl                = builtin
 wnaspi32, wow32		= builtin
 system, display, wprocs	= builtin
-wineps			= builtin
+wineps.drv		= builtin
 
 ;
 ; Options section. Does not need to be edited.
diff -u cvs/hq/wine/documentation/printing.sgml wine/documentation/printing.sgml
--- cvs/hq/wine/documentation/printing.sgml	Sat Apr 14 17:19:23 2001
+++ wine/documentation/printing.sgml	Tue May  1 16:09:32 2001
@@ -115,20 +115,20 @@
           To install it add
         </para>
         <screen>
-"Wine PostScript Driver" = "WINEPS,LPT1:"
+"Wine PostScript Driver" = "WINEPS.DRV,LPT1:"
         </screen>
         <para>
           to the [devices] section and
         </para>
         <screen>
-"Wine PostScript Driver" = "WINEPS,LPT1:,15,45"
+"Wine PostScript Driver" = "WINEPS.DRV,LPT1:,15,45"
         </screen>
         <para>
           to the [PrinterPorts] section of <filename>win.ini</filename> and to set it
           as the default printer also add
         </para>
         <screen>
-"device" = "Wine PostScript Driver,WINEPS,LPT1:"
+"device" = "Wine PostScript Driver,WINEPS.DRV,LPT1:"
         </screen>
         <para>
           to the [windows] section of <filename>~/.wine/config</filename> and ???
diff -u cvs/hq/wine/loader/loadorder.c wine/loader/loadorder.c
--- cvs/hq/wine/loader/loadorder.c	Sat Mar 24 13:52:11 2001
+++ wine/loader/loadorder.c	Tue May  1 16:18:03 2001
@@ -63,10 +63,11 @@
     { "winaspi",      { LOADORDER_BI,  0,             0, 0 } },
     { "windebug",     { LOADORDER_DLL, LOADORDER_BI,  0, 0 } },
     { "winedos",      { LOADORDER_BI,  0,             0, 0 } },
-    { "wineps",       { LOADORDER_BI,  0,             0, 0 } },
+    { "wineps.drv",   { LOADORDER_BI,  0,             0, 0 } },
     { "wing",         { LOADORDER_BI,  0,             0, 0 } },
     { "winmm",        { LOADORDER_BI,  0,             0, 0 } },
     { "winsock",      { LOADORDER_BI,  0,             0, 0 } },
+    { "winspool.drv", { LOADORDER_BI,  0,             0, 0 } },
     { "wnaspi32",     { LOADORDER_BI,  0,             0, 0 } },
     { "wow32",        { LOADORDER_BI,  0,             0, 0 } },
     { "wprocs",       { LOADORDER_BI,  0,             0, 0 } },